/*
 *	Copyright (c) 2005, Neil Goodman
 *	All rights reserved.
 *
 *	This software is provided "as-is", without any express or implied warranty.
 *	In no event shall the author be held liable for any damages arising from
 *	the use of this software. 
 */

//	===========================================================================

#ifndef _SkyController_H
#define _SkyController_H

//	==============================================================Include Files

#include <windows.h>

//	===========================================================Public Interface

//	....................................................................Outputs

enum EOutput
{
	eOutput_One 			= 0x30,												//	First output
	eOutput_Two 			= 0x31,												//	Second output (for dual-output controllers)
};

//	......................................................................Boxes

enum EBox
{
	eBox_Sky     			= 0,												//	Sky digibox
	eBox_SkyPlus 			= 12,												//	Sky+ digibox
};

//	...................................................................Commands

enum ECommand
{
	eCommand_Power			=  12,
	eCommand_Sky			= 128,
	eCommand_TV				= 132,

	eCommand_0           	=   0,
	eCommand_1           	=   1,
	eCommand_2           	=   2,
	eCommand_3           	=   3,
	eCommand_4           	=   4,
	eCommand_5           	=   5,
	eCommand_6           	=   6,
	eCommand_7           	=   7,
	eCommand_8           	=   8,
	eCommand_9           	=   9,

	eCommand_ChannelUp		=  32,
	eCommand_ChannelDown	=  33,

	eCommand_Up          	=  88,
	eCommand_Down        	=  89,
	eCommand_Left        	=  90,
	eCommand_Right       	=  91,
	eCommand_Select      	=  92,

	eCommand_Red         	= 109,
	eCommand_Green       	= 110,
	eCommand_Yellow      	= 111,
	eCommand_Blue        	= 112,

	eCommand_Text        	=  60,
	eCommand_I           	= 203,
	eCommand_Help        	= 129,
	eCommand_Backup      	= 131,

	eCommand_BoxOffice   	= 125,
	eCommand_Services    	= 126,
	eCommand_TVGuide     	= 204,
	eCommand_Interactive 	= 245,
};


//	.................................................................Controller

class SkyController 
{
public:
	//	Constructors And Destructor
			SkyController();
			~SkyController();

	//	Device Management
	bool	OpenDevice();
	void	CloseDevice();

	bool	IsDeviceOpen();

	//	Commands
	bool	SendCommand(EOutput Output, EBox Box, ECommand Command);

private:
	HANDLE	m_DeviceHandle;
};

//	===========================================================================

#endif	//	_SkyController_H
